#include <stdio.h>
#include <stdlib.h>


FILE *fptr;

/* main cache trace simulator function */
void simulate_cache() {
    /* This is sample code to show you how to
       get the next address and operation from the file */
    unsigned int address;
    int op;
    int counter = 0;

    while(1) { /* run forever until we see "0 0" */
	if(fscanf(fptr, "%d %x", &op, &address) != 2) {
	    printf("Invalid entry in trace file!\n");
	    exit(0);
	}

	if(op == 0 && address == 0)
	    break; /* saw 0 0 - break out of the loop */

	/* perform cache simulation using op and address here */

	/* WRITE ME */

	if(op == 1)
	    printf("Reading address: 0x%x\n", address);
	else 
	    printf("Writing address: 0x%x\n", address);

	counter++;

	/* end cache simulation code */
    }
    printf("Done processing, total number of memory operations: %d\n", counter);
}


int main(int argc, char **argv) {
    if(argc < 2) {
        printf("Usage: %s <tracefile>\n", argv[0]);
        exit(0);
    }
    
    if(NULL == (fptr = fopen(argv[1], "r"))) {
        printf("Error: cannot open input trace file\n");
        exit(0);
    }

    simulate_cache();
    fclose(fptr);
    return 0;
}
